﻿using System;
using System.Drawing;
using System.Windows.Forms;

using Emgu.CV;
using Emgu.CV.Structure;
using Emgu.CV.UI;
using Emgu.CV.GPU;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            using(Image<Bgr, Byte> image = new Image<Bgr, byte>("sample.png"))
            {
                long processingTime;

                Rectangle[] resultRectangleArray = PedestrianDetectionHelper.Find(image, out processingTime);

                foreach(Rectangle resultRectangle in resultRectangleArray)
                {
                    image.Draw(resultRectangle, new Bgr(Color.Red), 1);
                }

                ImageViewer.Show
                (
                    image,
                    string.Format
                    (
                        "{0}를 사용해 보행자 검출하기 : {1} 밀리초",
                        GpuInvoke.HasCuda ? "GPU" : "CPU",
                        processingTime
                    )
                );
            }
        }

        #endregion
    }
}